#include <stdio.h>
#include <x86intrin.h>

extern int movb (const void *s1, const void *s2, size_t n);
extern int movzbl (const void *s1, const void *s2, size_t n);

#define LOOP 3000000

char buf1[16];
char buf2[16];

int
main ()
{
  int i;
  unsigned long long start, end;
  unsigned long long diff;

  for (i = 0; i < sizeof (buf1); i++)
    {
      buf1[i] = i - 3;
      buf2[i] = i + 3;
    }

  start = __rdtsc ();
  for (i = 0; i < LOOP; i++)
    movb (buf1, buf2, sizeof (buf1));
  end = __rdtsc ();
  diff = end - start;

  printf ("movb  : %lld\n", diff);

  start = __rdtsc ();
  for (i = 0; i < LOOP; i++)
    movzbl (buf1, buf2, sizeof (buf1));
  end = __rdtsc ();
  diff = end - start;

  printf ("movzbl: %lld\n", diff);

  return 0;
}
